/*
 * This file was automatically generated by EvoSuite
 * Thu Jun 23 13:20:20 GMT 2022
 */

package ir.ramtung.impl2;

import ir.ramtung.sts01.LibraryException;
import org.junit.Test;
import static org.junit.Assert.*;
import static org.evosuite.runtime.EvoAssertions.*;
import ir.ramtung.impl2.Book;
import ir.ramtung.impl2.Document;
import ir.ramtung.impl2.Student;
import java.util.LinkedList;
import java.util.List;
import org.evosuite.runtime.EvoRunner;
import org.evosuite.runtime.EvoRunnerParameters;
import org.junit.runner.RunWith;

@RunWith(EvoRunner.class) @EvoRunnerParameters(mockJVMNonDeterminism = true, useVFS = true, useVNET = true, resetStaticState = true, separateClassLoader = true, useJEE = true) 
public class Student_ESTest extends Student_ESTest_scaffolding {

  @Test(timeout = 4000)
  public void test0()  throws Throwable  {
      Student student0 = new Student("", "ir.ramtung.sts01.LibraryException");
      LinkedList<Document> linkedList0 = new LinkedList<Document>();
      student0.docsBorrow = (List<Document>) linkedList0;
      assertTrue(student0.canBorrow());
      
      Book book0 = new Book("", 0);
      linkedList0.offerFirst(book0);
      linkedList0.add((Document) book0);
      linkedList0.add((Document) book0);
      boolean boolean0 = student0.canBorrow();
      assertFalse(boolean0);
  }

  @Test(timeout = 4000)
  public void test1()  throws Throwable  {
      Student student0 = new Student("ir.ramtung.impl2.Person", "c5F|(;HJ_&h8mZ");
      student0.docsBorrow = null;
      // Undeclared exception!
      try { 
        student0.canBorrow();
        fail("Expecting exception: NullPointerException");
      
      } catch(Throwable e) {
//          if (!(e instanceof LibraryException)) {
//              fail("Unexpected exception");
//          }
         //
         // no message in exception (getMessage() returned null)
         //
         verifyException("ir.ramtung.impl2.Student", e);
      }
  }

  @Test(timeout = 4000)
  public void test2()  throws Throwable  {
      Student student0 = new Student("", "ir.ramtung.sts01.LibraryException");
      LinkedList<Document> linkedList0 = new LinkedList<Document>();
      student0.docsBorrow = (List<Document>) linkedList0;
      assertTrue(student0.canBorrow());
      
      Book book0 = new Book("", 0);
      linkedList0.offerFirst(book0);
      linkedList0.add((Document) book0);
      boolean boolean0 = student0.canBorrow();
      assertFalse(boolean0);
  }

  @Test(timeout = 4000)
  public void test3()  throws Throwable  {
      Student student0 = new Student("", "");
      boolean boolean0 = student0.canBorrow();
      assertTrue(boolean0);
  }
}
